// APC9P203.pde
// Autoportrait Collectif
// 12 9 2013
// Sous Processing2.0.3
//
// Utilise la library minim v3.0 BETA inclus dans Processing 2.0.2:
//
// Lecture de JF1Modif.txt avec les 20 voix
// "sebastien" et "thomas" interverti par rapport a APC8P203

import ddf.minim.*;
String[] Voix = { 
  "", 
  "ama", "apageh", "Brian_fap", "denxiaoping", "domo_V3", 
  "FAP_soudan", "fatidiop", "jeunessechalette1", "jeunessechalette2", "jouineau", 
  "thomas", "sebastien", "rondatipica", "prieux", "mrfabienne", 
  "mmefabienne", "missmontargis", "missmilsaveur", "misscentrafrik", "millesourir"
};
// String NomFichierTexte = "14prieux.txt";
String NomFichierTexte = "JF1Modif.txt";

PFont maFonte;
float f;
int TempsZero, Temps, TempsDebut, TempsFin, TempsDuree = 0;
int NombreFichier = 20;
int Ligne = 0, NumeroVoix = 1, NumeroVoixAncien;
Minim minim;
AudioPlayer[] LecteurAudio = new AudioPlayer[NombreFichier];

Table table;
String Texte = "", Sac = "";
// Les colonnes du fichier au format texte sont séparées par des tab

void setup() {
  size(1024, 300); // "The size() function must be the first line in setup()"
  maFonte = loadFont("Futura-Medium-48.vlw");

  // "To use tab-separated data, include "tsv" in the options parameter."
  table = loadTable(NomFichierTexte, "header, tsv"); 
  println(table.getColumnCount() + " colonnes dans le fichier"); 
  println(table.getRowCount()    + " lignes dans le fichier"); 
  for (TableRow row : table.rows()) { 
    NumeroVoix = row.getInt(0);
    TempsDebut = row.getInt(1);
    TempsFin = row.getInt(2);
    Texte = row.getString(3);
    Sac = row.getString(4);
    println("Voix = " + NumeroVoix + "  TempsDebut = " + TempsDebut + "  TempsFin = " + TempsFin + "  Texte = " + Texte  + "  Sac = " + Sac);
  }
  println("----------------------------------------------");

  minim = new Minim(this);
  for (int i = 0; i < NombreFichier; i = i+1) {
    //  LecteurAudio[1] = minim.loadFile("prieux.wav");
    println("i = " + i +"    " + Voix[i+1] + ".wav");
    // LecteurAudio[i] = minim.loadFile(Voix[i+1] + ".wav");
    LecteurAudio[i] = minim.loadFile(Voix[i+1] + ".wav"); // Pb si 4 ou 6 pas de pb si 3 ou 5
    println("length = " + LecteurAudio[i].length());
  }
  println("----------------------------------------------");

  TempsZero = millis();
  textFont(maFonte, 24);
}

void draw() {
  Temps = (millis() - TempsZero);
  if (Temps > TempsDuree) {
    // Ligne = int(random(table.getRowCount()));
  if (Ligne < (table.getRowCount() - 1)) {
    Ligne = Ligne + 1;
    } else {
      Ligne = 0;
    }
    Texte = table.getString(Ligne, 3);
    //    while (Texte.equals ("")) { // Elimination des lignes sans texte
    //      // Ligne = int(random(table.getRowCount()));
    //      Ligne = Ligne + 1;
    //      Texte = table.getString(Ligne, 3);
    //    } 
    NumeroVoixAncien = NumeroVoix;
    NumeroVoix = table.getInt(Ligne, 0);
    TempsDebut = table.getInt(Ligne, 1);
    TempsFin   = table.getInt(Ligne, 2);
    Sac = table.getString(Ligne, 4);
    TempsDuree = TempsFin - TempsDebut;
    // TempsDebut = 0;
    println("Ligne = " + Ligne + "   Voix = " + NumeroVoix + "   TempsDebut = " + TempsDebut + "   Duree = " + TempsDuree + "    " + Texte);
    // LecteurAudio[1].play(TempsDebut);
    // LecteurAudio[4].play(TempsDebut);
    if ((NumeroVoix > 0) && (NumeroVoix <= NombreFichier) && (TempsDebut > 0)) {
      LecteurAudio[NumeroVoixAncien-1].pause();
      LecteurAudio[NumeroVoix-1].play(TempsDebut);
    } 
    else {  // on passe, probleme dans le fichier 
      NumeroVoix = NumeroVoixAncien;
    }          
    TempsZero = millis();
    // f = Temps / 100;
    f = TempsDebut / 100;
    background(0);
    text("Ligne = " + Ligne, 10, 130);
    text("Voix = " + NumeroVoix, 140, 130);
    text(f / 10 + " sec", 300, 130);
    text("Sac = " + Sac, 500, 130);
    text(Texte, 30, 180);
  }
}

void stop() {
  println("Stop");
  // "always close Minim audio classes when you finish with them"
  for (int i = 0; i < NombreFichier; i = i+1) {
    LecteurAudio[i].close();
  };
  minim.stop();
  super.stop();
}

